' Test MMC / SD Card
' Show the Card Capacity and the Card-Register CSD, CID, OCR and SD_Status
' First you have to init the Card in the File Config_MMCSD_HC.bas with
' $Include "Config_MMCSD_HC.bas"
' All Card registers are written with the MSB first to the Byte-array
' f.E. CSD(1) contains then MSB (Bit 120-127) of the CSD-Register

Dim xc as Byte          ' for Print - counter
dim xd as Byte          ' for Print - Counter

Print #1 , "Start of Card Analysis"
Print #1 , "Last Drive-Error-Code = " ; gbDriveError

' Check detected Card Type
Select Case MMCSD_CardType
   Case 1
      Print #1 , "MMC-Card detected"
   Case 2
      Print #1 , "SD-Card Spec. 1.x detected"
   case 4
      Print #1 , "SD-Card Spec. 2.0 detected"
   case 12
      Print #1 , "SD-Card Spec. 2.0 High Capacity detected"
   Case else
      Print #1 , "No Card detected"
end select

IF MMCSD_CardType > 0 then

' check the CSD Register

   Dim CSD(16) as Byte
   Print #1 , "Get CSD"
   CSD(1) = MMCSD_GetCSD()
   IF gbDriveError <> 0 then
      Print #1 , "Error at reading CSD"
   ELSE
      for xc = 1 to 16
         print #1 , hex(csd(xc)) ; " " ;
      next
      Print #1 , " "
   ENDIF

' Get the Card Capacity from the CSD Register

   Dim mmcsd_Size as Long
   Print #1 , "Get Card Capacity [KB]"
   mmcsd_Size = MMCSD_GetSize()
   IF gbDriveError <> 0 then
      Print #1 , "Error at reading CSD"
   ELSE
      Print #1 , "Card Capacity = ; " ; mmcsd_Size ; "kb  (1KB=1024 Bytes)"
   ENDIF

' Get the CID Register

   Dim CID(16) as Byte
   Print #1 , "Get CID"
   CID(1) = MMCSD_GetCID()
   IF gbDriveError <> 0 then
      Print #1 , "Error at reading CID"
   ELSE
      for xc = 1 to 16
         print #1 , hex(CID(xc)) ; " " ;
      next
      Print #1 , " "
   ENDIF

' Get the OCR Register

   Dim OCR(4) as Byte
   Print #1 , "Get OCR"
   OCR(1) = MMCSD_GetOCR()
   IF gbDriveError <> 0 then
      Print #1 , "Error at reading OCR"
   ELSE
      for xc = 1 to 4
         print #1 , hex(OCR(xc)) ; " " ;
      next
      Print #1 , " "
   ENDIF

   IF MMCSD_CardType > 1 then

' Get the SD_Status Register on SD-Cards

      Dim SD_Status(64) as Byte
      Print #1 , "Get SD_Status"
      SD_Status(1) = SD_GetSD_Status()
      IF gbDriveError <> 0 then
        Print #1 , "Error at reading SD_Status"
      ELSE
        for xc = 1 to 64
           print #1 , hex(SD_Status(xc)) ; " " ;
           xd = xc mod 8
           if xd = 0 then
              Print #1 , " "
           endif
        next
     End If
   ENDIF
ENDIF


print #1 , "End of Card Analysis"